import java.io.IOException;
import java.net.URL;

import javax.swing.JApplet; 

import org.apache.batik.dom.svg.SAXSVGDocumentFactory;
import org.apache.batik.swing.JSVGCanvas;
import org.apache.batik.util.XMLResourceDescriptor;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.events.Event;
import org.w3c.dom.events.EventListener;
import org.w3c.dom.events.EventTarget;

import netscape.javascript.JSObject;

public class AppletHTMLExample extends JApplet implements EventListener {

    protected JSVGCanvas canvas;
    protected Document doc;

    public void init() {
        canvas = new JSVGCanvas();
        getContentPane().add(canvas);
        try {
            String parser = XMLResourceDescriptor.getXMLParserClassName();
            SAXSVGDocumentFactory f = new SAXSVGDocumentFactory(parser);
            URL url = new URL(getCodeBase(), "circles2.svg");
            doc = f.createDocument(url.toString());
            ((EventTarget) doc.getElementById("red"))
                .addEventListener("click", AppletHTMLExample.this, false);
            ((EventTarget) doc.getElementById("green"))
                .addEventListener("click", AppletHTMLExample.this, false);
            ((EventTarget) doc.getElementById("blue"))
                .addEventListener("click", AppletHTMLExample.this, false);
        } catch (Exception ex) {
        }
    }

    public void start() {
        // Display the document.
        canvas.setDocumentState(JSVGCanvas.ALWAYS_DYNAMIC);
        canvas.setDocument(doc);
    }

    public void stop() {
        // Remove the document.
        canvas.setDocument(null);
    }

    public void destroy() {
        canvas.dispose();
    }

    public void handleEvent(Event evt) {
        String name = ((Element) evt.getTarget()).getAttributeNS(null, "id");
        JSObject win = JSObject.getWindow(this);
        JSObject document = (JSObject) win.getMember("document");
        JSObject div = (JSObject) document.call("getElementById", new Object[] { "msg" });
        div.setMember("innerHTML", "You clicked the " + name + " circle.");
    }
}
